package sets;


// immutable node, with only next and valid accessible attributes
class FrozenNode<T> extends SequentialNode<T>
{
    private boolean valid;

    @Override
    public T item() {
        throw new UnsupportedOperationException("Method item() is not implemented.");
    }

    @Override
    public int key() {
        throw new UnsupportedOperationException("Method key() is not implemented.");
    }

    @Override
    public void setItem(T item) {
        throw new UnsupportedOperationException("Method setItem() is not implemented.");
    }

    @Override
    public void setNext(Node<T> next) {
        throw new UnsupportedOperationException("Method setNext() is not implemented.");
    }

    @Override
    public boolean valid() {
        return this.valid;
    }

    @Override
    public boolean setValid() {
        throw new UnsupportedOperationException("Method setValid() is not implemented.");
    }

    FrozenNode(Node<T> node, boolean valid) {
        super(0);
        super.setNext(node);
        this.valid = valid;
    }
}
